GDB(1)

NOMBRE
gdb - El depurador GNU

SINOPSIS
gdb [-help] [-nh] [-nx] [-q] [-batch] [-cd=dir] [-f] [-b bps]
    [-tty=dev] [-s symfile] [-e prog] [-se prog] [-c core] [-p procID]
    [-x cmds] [-d dir] [prog|prog procID|prog core]

DESCRIPCIÓN
The purpose of a debugger such as GDB is to allow you to see what is going on "inside" another program while it executes -- or what another program was doing at the moment it crashed.

GDB puede hacer cuatro tipo de cosas (más otras cosas para dar soporte a éstas) para ayudarte a capturar errores en el acto:

•   Comenzar tu programa, especificando cualquier cosa que pueda afectar a su comportamiento.

•   Hacer que tu programa se pare al cumplirse las condiciones especificadas.

•   Examinar que ha pasado, cuando tu programa se ha parado.

•   Cambiar cosas de tu programa, de tal manera que puedas experimentar corrigiendo los efectos de un fallo y continuar para descubrir otros.

You can use GDB to debug programs written in C, C++, Fortran and Modula-2.

GDB is invoked with the shell command "gdb". Once started, it reads commands from the terminal until you tell it to exit with the GDB command "quit". You can get online help from GDB itself by using the command "help".

Se puede ejecutar "gdb" sin argumentos ni opciones; pero la manera más común de comenzar GDB es con uno o dos argumentos, especificando un programa ejecutable con el argumento:

 gdb programa

También puedes comenzar con un programa ejecutable y un fichero core específico:

 gdb programa core

You can, instead, specify a process ID as a second argument or use option "-p", if you want to debug a running process:

 gdb programa 1234  gdb -p 1234

would attach GDB to process 1234. With option -p you can omit the program filename.

Aquí están las ordenes más frecuentemente necesitadas en GDB:

break [fichero:]función
    Pone un punto de ruptura en función (en fichero).

run [arglist]
    Comienza tu programa (con arglist, si se especifica).

bt  Backtrace: muestra la pila del programa.

print expr
    Muestra el valor de una expresión.

c   Continua ejecutando tu programa (después de parar, p.e. en un punto de ruptura).

next
    Ejecuta la siguiente línea del programa (después de parar); pasa sobre cualquier llamada a función que apareciera en la línea.

edit [fichero:]función
    look at the program line where it is presently stopped.

list [fichero:]función
    type the text of the program in the vicinity of where it is presently stopped.

step
    Ejecuta la siguiente línea del programa (despué de parar); entrando en cualquier llamada a función que apareciera en la línea.

help [nombre]
    Muestra información sobre la orden GDB nombre, o información general sobre como utilizar GDB.

quit
    Salir de GDB.

For full details on GDB, see Using GDB: A Guide to the GNU Source-Level Debugger, by Richard M. Stallman and Roland H. Pesch. The same text is available online as the "gdb" entry in the "info" program.

OPCIONES
Any arguments other than options specify an executable file and core file (or process ID); that is, the first argument encountered with no associated option flag is equivalent to a -se option, and the second, if any, is equivalent to a -c option if it's the name of a file. Many options have both long and short forms; both are shown here. The long forms are also recognized if you truncate them, so long as enough of the option is present to be unambiguous. (If you prefer, you can flag option arguments with + rather than -, though we illustrate the more usual convention.)

Todas las opciones y argumentos en la línea de ordenes que des se procesann en orden secuencial. El orden es importante cuando se usa la opción -x.

-help
-h  Lista todas las opciones, con explicaciones breves.

-symbols=fichero
-s fichero
    Lee la tabla de símbolos del fichero fichero.

-write
    Enable writing into executable and core files.

-exec=fichero
-e fichero
    Usa el fichero fichero como el fichero ejecutable a ejecutar cuando sea adecuado, y para examinar los datos puros en unión con un volcado core.

-se=fichero
    Lee la tabla de símbolos del fichero fichero y la usa como el fichero ejecutable.

-core=fichero
-c fichero
    Usa el fichero fichero como un volcado core para examinar.

-command=fichero
-x fichero
    Ejecuta las ordenes GDB del fichero fichero.

-ex orden
    Execute given GDB command.

-directory=directorio
-d directorio
    Añade directorio al camino de búsqueda de los ficheros fuente.

-nh Do not execute commands from ~/.config/gdb/gdbinit, ~/.gdbinit, ~/.config/gdb/gdbearlyinit, or ~/.gdbearlyinit

-nx
-n  Do not execute commands from any .gdbinit or .gdbearlyinit initialization files.

-quiet
-q  "Quiet". No imprime los mensajes introductorios y de copyright. Estos mensajes también se suprimen en el modo de trabajo por lotes.

-batch
    Run in batch mode. Exit with status 0 after processing all the command files specified with -x (and .gdbinit, if not inhibited). Exit with nonzero status if an error occurs in executing the GDB commands in the command files.

    El modo de trabajo por lotes puede ser util cuando se ejecuta GDB como un filtro, pot ejemplo para bajarse y ejecutar un programa en otro ordenador; para hacer que sea más útil, el mensaje

     Program exited normally.

    (que se muestra normalmente siempre que un programa ejecutándose bajo el control de GDB termina) no se muestra cuando se ejecuta en modo de trabajo por lotes.

-cd=directorio
    Ejecuta GDB usando directorio como directorio de trabajo, en lugar del directorio actual.

-fullname
-f  Emacs sets this option when it runs GDB as a subprocess. It tells GDB to output the full file name and line number in a standard, recognizable fashion each time a stack frame is displayed (which includes each time the program stops). This recognizable format looks like two \032 characters, followed by the file name, line number and character position separated by colons, and a newline. The Emacs-to-GDB interface program uses the two \032 characters as a signal to display the source code for the frame.

-b bps
    Fija la velocidad de la línea (ratio de baudios o bits por segundo) de cualquier interface serie usado por GDB para la depuración remota.

-tty=dispositivo
    Se ejecuta usando dispositivo como la entrada y salida estándar de tu programa.

VÉASE TAMBIÉN
La documentación completa de B se mantiene como manual Texinfo. Si los programas "info" y "gdb" están adecuadamente instalados en su sistema, la orden

 info gdb

debería acceder al manual completo.

Using GDB: A Guide to the GNU Source-Level Debugger, Richard M. Stallman and Roland H. Pesch, July 1991.

COPYRIGHT
Copyright (c) 1988-2021 Free Software Foundation, Inc.

Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.3 or any later version published by the Free Software Foundation; with the Invariant Sections being "Free Software" and "Free Software Needs Free Documentation", with the Front-Cover Texts being "A GNU Manual," and with the Back-Cover Texts as in (a) below.

(a) The FSF's Back-Cover Text is: "You are free to copy and modify this GNU Manual. Buying copies from GNU Press supports the FSF in developing GNU and promoting software freedom."

TRADUCCIÓN
La traducción al español de esta página del manual fue creada por Antonio Flores Gil <aflores@ditec.um.es> Esta traducción es documentación libre; lea la GNU General Public License Version 3 (https://www.gnu.org/licenses/gpl-3.0.html) o posterior con respecto a las condiciones de copyright. No existe NINGUNA RESPONSABILIDAD. Si encuentra algún error en la traducción de esta página del manual, envíe un correo electrónico a debian-l10n-spanish@lists.debian.org>..